
/*************************************************************/
/**                                                         **/
/**            Convert GIF - to - GameBoy format            **/
/**                                                         **/
/**                       Version 1.0                       **/
/*************************************************************/


/*  By Jeff Frohwein       */
/*  First edit: 16-Feb-96  */
/*  Last edit: 17-Feb-96   */

#include <crt0.h>
#include <go32.h>
#include <pc.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <dos.h>
#include <conio.h>
#include <dpmi.h>
//#include <graph.h>

//#include <i86.h>


/**********************************************************/
/*** NOTICE: sizeof(byte)=1 and sizeof(word)=2          ***/
/**********************************************************/
typedef unsigned char  byte;
typedef unsigned short word;
typedef short WORD;
typedef unsigned short UWORD;
typedef char TINY;
typedef unsigned char UTINY;
typedef int LONG;
typedef unsigned ULONG;

#define VGAOFFSET 75+(320*30)
#define SCROLL_DISTANCE 40
#define CLRADJ 8

static int bad_code_count; //,numwritten;
byte palette[768];
//byte GifFile=0;            /* Flag whether title GIF present or not        */
//static byte *GIF=NULL;          /* Pointer to GIF 64kB                          */
byte *VGA = (byte*)0xa0000;  /* Pointer to VGA buffer                    */
//char *P;
char outb[8];
byte BUF[321];
char *pBUF;
int TileCount;

byte GifPalette[768];
int BlackUpperLimit = 100*3; //256-128;    //0-115
int BrownUpperLimit = 150*3; //512-128;    //115-180
int GreyUpperLimit =  200*3; //768-128;     //180-255
int dither = 1;

/* prototypes */


/*Include src code files */

#include "gif.c"
#include "vga.c"
#include "tile.c"


int main(int argc,char *argv[])
   {
//   char line[81];
//   int J;
   int i;
   int x = 0;
   int y = 0;
   int ProgramExit = 0;
   char GifFileName[] = "pic.gif";
//   char GifPalette[768];
   char *pGifBytes;
   char *pScrnBuf;
   char *pal;
   FILE *G;

//   pGifBytes = 0;

   if ((G=fopen("shades.dat","r"))!=NULL)
      {
      fscanf(G,"%d,%d,%d,%d\n",&BlackUpperLimit,&BrownUpperLimit,&GreyUpperLimit,&dither);
      fclose(G);
      }
   else
      {
      printf("File \"shades.dat\" not found!\n");
      exit(1);
      }

   printf ("Allocating GIF decoding space...");
   pGifBytes=malloc(100000);
   printf ((pGifBytes)? "OK\n":"FAILED\n");
   if (pGifBytes == 0) exit(1);

   printf ("Allocating scrn buf space...");
   pScrnBuf=malloc(64000);
   printf ((pScrnBuf)? "OK\n":"FAILED\n");
   if (pScrnBuf == 0) exit(1);

   /* Load GIF file. Exit if failure */
   if (LoadGif (GifFileName,GifPalette,pGifBytes) == 0)
     exit(1);

   if ( ((width&7)!=0) || ((height&7)!=0) )
      {
      printf ("ERROR: Picture width & height must be multiples of 8 pixels!\n");
      exit(1);
      }

   AllocateTileBuf ();

//   VGA_SetFullScreenMode();

//   set_palette();


   VGA_Init (GifPalette,pGifBytes);

   for (i=0;i<321;i++)
      BUF[i] = i;

//   dosmemput (pGifBytes,64000,0xA0000);

//   pBUF=BUF;

//   dosmemput(pBUF,321,0xA0000);

   ClearScrnBuf(pScrnBuf);

   MakeAllTiles(pGifBytes);
   SetWindow(0,0,pGifBytes,pScrnBuf);

   while (ProgramExit == 0)
      {
      switch (getch())
         {
         case 0x20 :
            pal = GifPalette;
            VGA_SetPalette (pal,0,256);
            break;
         case 0x61 :  //Left
            if (x!=0)
               x=x-SCROLL_DISTANCE;
            break;
         case 0x73 :  //Right
            if (x+320<width)
               x=x+SCROLL_DISTANCE;
            break;
//         case 0x77 :  //Up
//            y=y-SCROLL_DISTANCE;
//            break;
//         case 0x7a :  //Down
//            y=y+SCROLL_DISTANCE;
//            break;
         case 0x31 :   //Darker Black
            if (BlackUpperLimit < CLRADJ)
               BlackUpperLimit = 0;
            else
               BlackUpperLimit -= CLRADJ;
            MakeAllTiles(pGifBytes);
            break;
         case 0x32 :   //Lighter Black
            if (BlackUpperLimit < BrownUpperLimit)
               {
               BlackUpperLimit += CLRADJ;
               if (BlackUpperLimit >= BrownUpperLimit)
                  BlackUpperLimit = BrownUpperLimit-1;
               }
            MakeAllTiles(pGifBytes);
            break;
         case 0x33 :   //Darker Brown
            if (BrownUpperLimit > BlackUpperLimit)
               {
               BrownUpperLimit -= CLRADJ;
               if (BrownUpperLimit <= BlackUpperLimit)
                  BrownUpperLimit = BlackUpperLimit+1;
               }
            MakeAllTiles(pGifBytes);
            break;
         case 0x34 :   //Lighter Brown
            if (BrownUpperLimit < GreyUpperLimit)
               {
               BrownUpperLimit += CLRADJ;
               if (BrownUpperLimit >= GreyUpperLimit)
                  BrownUpperLimit = GreyUpperLimit-1;
               }
            MakeAllTiles(pGifBytes);
            break;
         case 0x35 :   //Darker Grey
            if (GreyUpperLimit > BrownUpperLimit)
               {
               GreyUpperLimit -= CLRADJ;
               if (GreyUpperLimit <= BrownUpperLimit)
                  GreyUpperLimit = BrownUpperLimit+1;
               }
            MakeAllTiles(pGifBytes);
            break;
         case 0x36 :   //Lighter Brown
            if (GreyUpperLimit < 256*3)
               {
               GreyUpperLimit += CLRADJ;
               if (GreyUpperLimit >= 256*3)
                  GreyUpperLimit = 768-1;
               }
            MakeAllTiles(pGifBytes);
            break;
         case 0x64 :  //toggle dither
            dither ^= 1;
            MakeAllTiles(pGifBytes);
            break;
         case 27   :  //Escape
            ProgramExit = 1;
            break;
         }
      SetWindow(x,y,pGifBytes,pScrnBuf);
      }

//   Vindex=VGAOFFSET;
//   J = decoder(128);
//   fclose(G);

   VGA_Reset();

//   PrintTiles();
   WriteTileAndMapData();

//   PrintTiles();

//   exit(1);

//   gets(line);

//   convert_colors();

//   set_gb_colors();

//   set_palette();

//   if ((G=fopen("image.dat","w"))!=NULL)
//      {
//      gets(line);
//      out_data();

//      fclose(G);
//      }


//   VGA_Reset ();

   if ((G=fopen("shades.dat","w"))!=NULL)
      {
      fprintf(G,"%d,%d,%d,%d\n",BlackUpperLimit,BrownUpperLimit,GreyUpperLimit,dither);
      fclose(G);
      }

//   if ((G=fopen("shades.dat","r"))!=NULL)
//      {
//      fscanf(G,"%d,%d,%d\n",&i,&j,&k);
//      printf("%d,%d,%d done\n",i,j,k);
//      fclose(G);
//      }

   return(0);
}

