
byte *pTileBuf;
byte *pMapBuf;
byte TempTile[16];

void AllocateTileBuf (void)
   {
   printf ("Allocating tile buffer space...");
   pTileBuf=malloc(16*256);
   printf ((pTileBuf)? "OK\n":"FAILED\n");
   if (pTileBuf == 0) exit(1);

   printf ("Allocating tile map space...");
   pMapBuf=malloc((height/8)*(width/8));
   printf ((pMapBuf)? "OK\n":"FAILED\n");
   if (pMapBuf == 0) exit(1);
   }

void MakeTile (int xoff,int yoff, char *pGifBytes)
   {
   char i;
   byte j = 0;
   int c1,c2;
   int x,y;

   for (y=0; y<8; y++)
      {
      c1 = c2 = 0;
      for (x=0; x<8; x++)
         {
         c1 = c1 * 2;
         c2 = c2 * 2;
         i = xlat(x+xoff,y+yoff,pGifBytes[(width*(y+yoff))+x+xoff]);
         if (i & 1) c2++;
         if (i & 2) c1++;
         }
      TempTile[j++] = ~c1;
      TempTile[j++] = ~c2;
      }
   }

void MakeAllTiles (char *pGifBytes)
   {
   int i,x,y;
   int index;
   int MapIndex = 0;
   int Similar;


   TileCount = 0;

   for (y=0; y<height; y+=8)
      for (x=0; x<width; x+=8)
         {
         if (TileCount<256)
            {

            /* Tile buffer not yet full so add this one if unique. */
            MakeTile (x,y,pGifBytes);
            index = 0;
            Similar = 0;

            while ( (Similar == 0) &&
                    (index < TileCount) )
               {
               Similar = 1;
               for (i=0; i<16; i++)
                  if (TempTile[i] != pTileBuf[(index*16)+i])
                     Similar = 0;

               index++;
               }

            if (Similar == 0 )
               {
               /* Add tile to buffer */

               for (i=0; i<16; i++)
                  pTileBuf[(TileCount*16)+i] = TempTile[i];
               pMapBuf[MapIndex++] = TileCount;
               TileCount++;
               }
            else
               pMapBuf[MapIndex++] = index - 1;
            }
         }
   }

void PrintTiles (void)
   {
   int x,y;

   for (y=0; y<4; y++)
      {
      for (x=0; x<16; x++)
         printf("%x ",(unsigned int) pTileBuf[(y*16)+x]);
      printf("\n");
      }
   }

void WriteTileAndMapData (void)
   {
   FILE *ofp;
//   byte c;

   if ((ofp = fopen("pic.its", "wb")) == NULL)
      {
      printf("Error opening output file 'pic.its'.\n");
      }
   else
      {
      int i;

      for (i=0; i<(16*TileCount); i++)
         {
         fputc(pTileBuf[i],ofp);
         }
      (void) fclose(ofp);
      }

   if ((ofp = fopen("pic.itm", "wb")) == NULL)
      {
      printf("Error opening output file 'pic.itm'.\n");
      }
   else
      {
      int i;

      for (i=0; i< ((width/8)*(height/8)); i++)
         {
         fputc(pMapBuf[i],ofp);
         }
      (void) fclose(ofp);
      }
   }


