
#define COLOR0 0
#define COLOR1 1
#define COLOR2 2
#define COLOR3 3

#if 0
  #define SCRNCOLOR0 4
  #define SCRNCOLOR1 8
  #define SCRNCOLOR2 12
  #define SCRNCOLOR3 15
#else
  #define SCRNCOLOR0 0   //4
  #define SCRNCOLOR1 1  //8
  #define SCRNCOLOR2 2  //12
  #define SCRNCOLOR3 3  //15
#endif

union   REGS    R;
static int nOldVideoMode;

static void VGA_SetPalette (byte *pal,int start,int numcolors)
{
 int i;
 disable ();
 while ((inportb(0x3DA)&0x08)!=0); /* Wait until vertical retrace is off */
 while ((inportb(0x3DA)&0x08)==0); /* Now wait until it is on */
 outportb (0x3C8,start);
 for (i=0;i<numcolors*3;++i)
  outportb(0x3C9,pal[i]/4);
 enable ();
}

void VGA_Reset (void)            /* Reset old video mode */
{
 __dpmi_regs r;
 r.x.ax=(short)nOldVideoMode;
 __dpmi_int (0x10, &r);
}

static int VGA_Init (char *pGifPalette,char *pGifBytes)
{
 int i;
 byte GifPal[768];


// static byte fspal[256*3];
// static byte pal[64*3]={ 0,0,0,                 /* Overscan colour */
//                         0xFF,0xFF,0xFF,        /* Background colours */
//                         0xB0,0xB0,0xB0,
//                         0x60,0x60,0x60,
//                         0x00,0x00,0x00,
//                         0xFF,0xFF,0xFF,        /* Sprite colours */
//                         0xB0,0xB0,0xB0,
//                         0x60,0x60,0x60,
//                         0x00,0x00,0x00,
//                         0xFF,0xFF,0xFF,        /* Window colours */
//                         0xB0,0xB0,0xB0,
//                         0x60,0x60,0x60,
//                         0x00,0x00,0x00 };

// int a,b;
 __dpmi_regs r;
 r.x.ax=0x0F00;
 __dpmi_int (0x10,&r);
 nOldVideoMode=(int)(r.h.al & 0x7F);
 r.x.ax=0x0013;
 __dpmi_int (0x10,&r);

 for (i=0; i<768; i++)
    GifPal[i] = pGifPalette[i];

GifPal[0] = 0;
GifPal[1] = 0;
GifPal[2] = 0;
GifPal[3] = 128;
GifPal[4] = 128;
GifPal[5] = 128;
GifPal[6] = 192;
GifPal[7] = 192;
GifPal[8] = 192;
GifPal[9] = 255;
GifPal[10] = 255;
GifPal[11] = 255;

 //VGA_SetFullScreenMode ();

 VGA_SetPalette (GifPal,0,256);

 //dosmemput (pGifBytes,64000,0xA0000);

 return 1;
}

char DitherVal(int x, int y, int pattern)
   {
   char v = 0;

   switch (pattern)
      {
      case 1 :
         if ( ((x&3)==1) && ((y&3)==1)) v=1;
         if ( ((x&3)==3) && ((y&3)==3)) v=1;
         break;
      case 2 :
         if ( ((x&3)==1) && ((y&1)==0)) v=1;
         if ( ((x&3)==3) && ((y&1)==1)) v=1;
         break;
      case 3 :
         if ( ((x&3) + (y&3)) == 2) v=1;
         if ( ((x&3)==3) && ((y&3)==3) ) v=1;
         if ( ((x&3)==3) && ((y&3)==1) ) v=1;
         if ( ((x&3)==1) && ((y&3)==3) ) v=1;
         break;
      case 4 :
         if ( (x&1) ^ (y&1) ) v=1;
         break;
      case 5 :
         v = 1;
         if ( ((x&3) + (y&3)) == 2) v=0;
         if ( ((x&3)==3) && ((y&3)==3) ) v=0;
         if ( ((x&3)==3) && ((y&3)==1) ) v=0;
         if ( ((x&3)==1) && ((y&3)==3) ) v=0;
         break;
      case 6 :
         v = 1;
         if ( ((x&3)==1) && ((y&1)==0)) v=0;
         if ( ((x&3)==3) && ((y&1)==1)) v=0;
         break;
      case 7 :
         v = 1;
         if ( ((x&3)==1) && ((y&3)==1)) v=0;
         if ( ((x&3)==3) && ((y&3)==3)) v=0;
         break;
      }
   return(v);
   }

char ColorVal (int x, int y, int intensity)
   {
   char r = COLOR3;

   if (dither)
      {
      /* Dither the GIF */
      if (intensity < BlackUpperLimit)
         {
         if (DitherVal(x,y,(8*intensity)/BlackUpperLimit))
            r=COLOR1;
         else
            r=COLOR0;
         }
      else
         if (intensity < BrownUpperLimit)
            {
            if (DitherVal(x,y,(8*(intensity-BlackUpperLimit))/(BrownUpperLimit-BlackUpperLimit)))
               r=COLOR2;
            else
               r=COLOR1;
            }
         else
            if (intensity < GreyUpperLimit)
               {
               if (DitherVal(x,y,(8*(intensity-BrownUpperLimit))/(GreyUpperLimit-BrownUpperLimit)))
                  r=COLOR3;
               else
                  r=COLOR2;
               }
      }
   else
      {
      /* No dither for the GIF */
      if (intensity < BlackUpperLimit)
         r=COLOR0;
      else
         if (intensity < BrownUpperLimit)
            r=COLOR1;
         else
            if (intensity < GreyUpperLimit)
               r=COLOR2;
      }
   return (r);
   }

char xlat (int x, int y, byte i)
   {
   int intensity;

   intensity = GifPalette[(i*3)+0] +
               GifPalette[(i*3)+1] +
               GifPalette[(i*3)+2];

   return (ColorVal(x,y,intensity));
   }

char ScrnClr (byte i)
   {
   int r = SCRNCOLOR3;

   switch (i)
      {
      case 0:
         r = SCRNCOLOR0;
         break;
      case 1:
         r = SCRNCOLOR1;
         break;
      case 2:
         r = SCRNCOLOR2;
         break;
      }
   return (r);
   }

void DrawTotalTiles (char *pScrnBuf, int total)
   {
   char c;
   int i;

   /* Erase old bar */
   for (i=0; i<(320*3); i++)
      pScrnBuf[(320*197)+i] = SCRNCOLOR0;

   pScrnBuf[(320*195)+111] = SCRNCOLOR2;
   pScrnBuf[(320*196)+111] = SCRNCOLOR2;

   pScrnBuf[(320*194)+127] = SCRNCOLOR2;
   pScrnBuf[(320*195)+127] = SCRNCOLOR2;
   pScrnBuf[(320*196)+127] = SCRNCOLOR2;

   pScrnBuf[(320*194)+255] = SCRNCOLOR2;
   pScrnBuf[(320*195)+255] = SCRNCOLOR2;
   pScrnBuf[(320*196)+255] = SCRNCOLOR2;

   if (total > (320*3)) total = 320*3;

   for (i=0; i<total; i++)
      {
      if (i>255) c = SCRNCOLOR3; else c = SCRNCOLOR2;
      pScrnBuf[(320*(197+(i&1)))+i] = c;
      }
   }

void ClearScrnBuf (char *pScrnBuf)
   {
   int i,x,y;

   for (i=0; i<64000; i++)
      pScrnBuf[i] = 0;

   /*Draw 4 colors at bottom */
   for (x=0; x<16; x++)
      for (y=0; y<16; y++)
         {
         pScrnBuf[(320*(180+y))+x] = SCRNCOLOR0;
         pScrnBuf[(320*(180+y))+x+16] = SCRNCOLOR1;
         pScrnBuf[(320*(180+y))+x+32] = SCRNCOLOR2;
         pScrnBuf[(320*(180+y))+x+48] = SCRNCOLOR3;
         }
   }

void SetWindow(int xoff, int yoff, char *pGifBytes, char *pScrnBuf)
   {
   int i,x;
   int y = 0;

   while ( (y<height-yoff) &&
           (y<200) )
      {

      if (width-xoff<320)
         {
         /* Gifs smaller then 320 width */
         for (x=0; x<width-xoff; x++)
            pScrnBuf[x+(y*320)] = ScrnClr(xlat(x,y,pGifBytes[x+xoff+((y+yoff)*width)]));
         while (x<320)
            {
            pScrnBuf[x+(y*320)] = SCRNCOLOR0;
            x++;
            }
         }
      else
         {
         /* Gifs 320 or wider */
         for (x=0; x<320; x++)
            pScrnBuf[x+(y*320)] = ScrnClr(xlat(x,y,pGifBytes[x+xoff+((y+yoff)*width)]));
         }

      y++;
      }

   /* Draw color bar at bottom of scrn */

   for (i=0; i<256; i++)
      {
      pScrnBuf[(170*320)+i] = ScrnClr(ColorVal(i,0,i*3));
      pScrnBuf[(171*320)+i] = ScrnClr(ColorVal(i,1,i*3));
      pScrnBuf[(172*320)+i] = ScrnClr(ColorVal(i,2,i*3));
      pScrnBuf[(173*320)+i] = ScrnClr(ColorVal(i,3,i*3));
      }

   /* Draw tile count display */
   DrawTotalTiles(pScrnBuf, TileCount);

   dosmemput (pScrnBuf,64000,0xA0000);
   }

